package com.jihengbel.intelligent.applicationtask.common;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class CommonUtil {

    /**
     * 时间转字符串
     * @param date
     * @param format
     * @return
     */
    public static String  getDateStr(Date date , String format){//"yyyy-MM-dd HH:mm:ss"
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(date);
    }

    /**
     * 获取时间是星期几
     * @param date
     * @return
     */
    public static int getWeekOfDate(Date date) {
        int[] weekDays = { 7, 1, 2, 3, 4,5, 6 };
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        int w = cal.get(Calendar.DAY_OF_WEEK) - 1;
        return weekDays[w<0?0:w];

    }

    /**
     * 获取时间是这个月几号
     * @param date
     * @return
     */
    public static int getMonthOfDate(Date date) {
        Calendar newTime = Calendar.getInstance();
        newTime.setTime(date);
        return  newTime.get(Calendar.DAY_OF_MONTH);
    }


    /**
     * 添加多少分钟的时间
     * @param date
     * @param format
     * @param min
     * @return
     */
    public static Date  getStrDate(String date , String format,int min) throws ParseException {//"yyyy-MM-dd HH:mm:ss"
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        Date current= sdf.parse(date);
        Calendar newTime = Calendar.getInstance();
        newTime.setTime(current);
        newTime.add(Calendar.MINUTE,min);
        return newTime.getTime();
    }

    /**
     *  获取当前时间是不是大野提醒时间大于需要提醒
     * @param changeTime
     * @param now
     * @return
     * @throws ParseException
     */
    public static boolean  getDateCompare(Date changeTime , Date now , boolean flag) throws ParseException {
        Calendar c1 = Calendar.getInstance();
        c1.setTime(changeTime);
        Calendar c2 = Calendar.getInstance();
        c2.setTime(now);
        if(!flag){
            if(c1.compareTo(c2)>0 ){
                return false;
            }else{
                return true;
            }
        }else{
            if(c1.compareTo(c2)==-1 ){
                return true;
            }else{
                return false;
            }
        }

    }




    public static void main(String[] args) throws ParseException {
     //   getDateCompare(getStrDate("2011-11-11 10:00" , "yyyy-MM-dd HH:mm",120) , new Date());
    }
}
