package com.jihengbel.intelligent.applicationtask.init;

import com.jihengbel.intelligent.applicationtask.common.CommonUtil;
import com.jihengbel.intelligent.applicationtask.entry.ApproveEntry;
import com.jihengbel.intelligent.applicationtask.entry.FirstCalendar;
import com.jihengbel.intelligent.applicationtask.entry.FirstTask;
import com.jihengbel.intelligent.applicationtask.service.FirstTaskService;
import com.jihengbel.intelligent.applicationtask.service.OnsiteTaskService;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.*;
import java.util.concurrent.Callable;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.FutureTask;

/**
 * 首件任务定时器
 */
@DisallowConcurrentExecution
public class AutoApproveErrorTaskJob implements Job {
    private static Logger log = LoggerFactory.getLogger(AutoApproveErrorTaskJob.class);

    private static int type2=2;
    private static int type3=3;
    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {
        ConcurrentMap<String, Object> paramMap = (ConcurrentMap<String, Object>) context.getJobDetail().getJobDataMap().get(QuartzManager.JOB_PARAM_NAME);
        try {
            createTask(paramMap);// 执行任务
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

    /**
     * 创建Task主方法
     *
     * @param paramMap
     */
    public void createTask(ConcurrentMap<String, Object> paramMap) {
        Integer result = 0;//没什么意义只是为了不出现整体并行
        List<FutureTask<Integer>> tasks = new ArrayList<>();
        tasks.add(getFutureTask(paramMap, type2));
        tasks.add(getFutureTask(paramMap, type3));
//        tasks.add(get200FutureTask(paramMap));
        try {
            for (FutureTask<Integer> t : tasks) {
                t.get();
            }//等等所有线程结束
        } catch (Throwable e) {
            e.printStackTrace();
        }

    }

    private FutureTask<Integer> getFutureTask(ConcurrentMap<String, Object> paramMap,int type) {
        FutureTask<Integer> task = new FutureTask<Integer>(new AutoApproveErrorTaskJob.approveTask(paramMap,type));
        Thread thread = new Thread(task);
        thread.start();  //开启线程
        return task;
    }


    /**
     * 生产任务
     */
    public class approveTask implements Callable<Integer> {

        private ConcurrentMap<String, Object> paramMap;
        private int type;


        public approveTask(ConcurrentMap<String, Object> paramMap, int type) {
            this.paramMap = paramMap;
            this.type = type;
        }

        @Override
        public Integer call() throws Exception {
            FirstTaskService firstTaskService = (FirstTaskService) paramMap.get("firstTaskService");
            OnsiteTaskService onsiteTaskService = (OnsiteTaskService) paramMap.get("onsiteTaskService");
            HashMap queryMap = new HashMap();
            if (type == type2) {//首件
                int maxlevel = firstTaskService.getMaxApproveLevel(null);
                queryMap.put("approval_level", maxlevel);
                List<ApproveEntry>  approves=firstTaskService.getApproveTaskNoDeal(queryMap);
                for(ApproveEntry ap:approves){
                    try {
                        firstTaskService.addTaskForNext(ap);
                    }catch (Throwable e){
                        e.printStackTrace();
                    }
                }
            } else {//防错
                int maxlevel = onsiteTaskService.getMaxApproveLevel(null);
                queryMap.put("approval_level", maxlevel);
                List<ApproveEntry>  approves=onsiteTaskService.getApproveTaskNoDeal(queryMap);
                for(ApproveEntry ap:approves){
                    try {
                        onsiteTaskService.addTaskForNext(ap);
                    }catch (Throwable e){
                        e.printStackTrace();
                    }
                }
            }

            return 0;
        }
    }

}
